VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsDriverVxm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'**********************************************************************************
'*** Velmex, Inc. VXM Serial Driver Class Wrapper
'*** NOTES:
'*** 1.) Driver MUST be in same directory as application
'*** 2.) To escape any driver functions that may appear locked up, call the EscapeDriverFunctionTrue()
'*** 3.) If the EscapeDriverFunctionTrue() has been called then call the EscapeDriverFunctionFalse() before calling another function
'***
'*** To see function call details see the public functions below
'*** CCN 09-22-05
'**********************************************************************************

'Driver Function Prototypes
Private Declare Sub SetTempBufferCallback Lib "Velmex VXM Serial Driver.dll" (hTxtCallback As Long)
Private Declare Sub SetBufferCallback Lib "Velmex VXM Serial Driver.dll" (hTxtCallback As Long)
Private Declare Sub SetTerminalCallback Lib "Velmex VXM Serial Driver.dll" (hTxtCallback As Long)
Private Declare Sub SetReportCallback Lib "Velmex VXM Serial Driver.dll" (hTxtCallback As Long)


'Debug Window Functions
Private Declare Function ShowForm Lib "Velmex VXM Serial Driver.dll" () As Long     'Show driver debug form
Private Declare Function HideForm Lib "Velmex VXM Serial Driver.dll" () As Long     'Hide driver debug form
Private Declare Function WindowHandle Lib "Velmex VXM Serial Driver.dll" () As Long                     'Return the Window Handle of the form
Private Declare Function IsFormOpen Lib "Velmex VXM Serial Driver.dll" () As Long                   'Determine if form open so not to crash if parent leaves

Private Declare Function MoveForm Lib "Velmex VXM Serial Driver.dll" (x As Long, y As Long) As Long                 'Move the Dialog Position

'Core Functions
Private Declare Function OpenPort Lib "Velmex VXM Serial Driver.dll" (ByVal ComPortNumber As Long, ByVal ComPortBaudRate As Long) As Long   'Configure and open serial port
Private Declare Function IsPortOpen Lib "Velmex VXM Serial Driver.dll" () As Long                      'Determine if port is already open (mostly for labview users)
Private Declare Function ClosePort Lib "Velmex VXM Serial Driver.dll" () As Long    'Close serial port
Private Declare Function SendToPort Lib "Velmex VXM Serial Driver.dll" (ByVal CommandOut As String) As Long     'Send Command to device via Cptr or actual string
Private Declare Function ReadFromPort Lib "Velmex VXM Serial Driver.dll" () As String   'Get reply from device
Private Declare Function ReadAndThenClearFromPort Lib "Velmex VXM Serial Driver.dll" () As String   'Get reply from device
Private Declare Function CountCharsAtPort Lib "Velmex VXM Serial Driver.dll" () As Long     'Count Number of Chars at port
Private Declare Function SearchForChars Lib "Velmex VXM Serial Driver.dll" (ByVal CharsToFind As String) As Long

Private Declare Function CleanTerminal Lib "Velmex VXM Serial Driver.dll" () As Long
Private Declare Function ClearTerminal Lib "Velmex VXM Serial Driver.dll" () As Long
Private Declare Function GetTerminal Lib "Velmex VXM Serial Driver.dll" () As String

Private Declare Function ClearPort Lib "Velmex VXM Serial Driver.dll" () As Long    'Clear buffer
Private Declare Function RemoveFromPort Lib "Velmex VXM Serial Driver.dll" (ByVal StringToRemove As String) As Long 'Remove chars from buffer
     
'Verify Control Status Functions
Private Declare Function VerifyControlStatus Lib "Velmex VXM Serial Driver.dll" () As String    'Verify control status
Private Declare Function StateCheck Lib "Velmex VXM Serial Driver.dll" (Optional ByVal StateBuffer As String) As String

'Functions for escaping functions locked into getting reply from VXM
Private Declare Function FunctionEscapeTrue Lib "Velmex VXM Serial Driver.dll" () As Long   'Escape any stuck driver functions
Private Declare Function FunctionEscapeFalse Lib "Velmex VXM Serial Driver.dll" () As Long  'Reset escape so functions work
Private Declare Function AreAllFunctionsEnabled Lib "Velmex VXM Serial Driver.dll" () As Long

'Control Online, Offline, and Kill Program functions
Private Declare Function Online Lib "Velmex VXM Serial Driver.dll" () As Long   'Control Online
Private Declare Function Offline Lib "Velmex VXM Serial Driver.dll" () As Long  'Control Offline
Private Declare Function KillVxmProgram Lib "Velmex VXM Serial Driver.dll" () As Long   'Stop VXM program
Private Declare Function StopVxmProgram Lib "Velmex VXM Serial Driver.dll" () As Long

'Motor position functions
Private Declare Function GetMotorPosition Lib "Velmex VXM Serial Driver.dll" (ByVal MotorNumber As Long) As String      'Get motor position
   
'Wait for a char
Private Declare Function WaitForChar Lib "Velmex VXM Serial Driver.dll" (ByVal CharToWaitFor As String, Optional ByVal TimeOutTime As Currency) As Long     'Wait for a certain character
Private Declare Function RunProgram Lib "Velmex VXM Serial Driver.dll" () As Long   'Run program
Private Declare Function RunProgramAndWaitForFinish Lib "Velmex VXM Serial Driver.dll" (Optional ByVal TimeOutTime As Currency) As Long   'Run program and wait for program to finish
           
'Detect VXM
Private Declare Function DetectControl Lib "Velmex VXM Serial Driver.dll" (MaxPortsToScan As Long, Optional hTxtCallback As Long) As Long                          'Added due to VerifyControlStatus delayed scan by 1 sec per port setting
Private Declare Function GetCurrentPort Lib "Velmex VXM Serial Driver.dll" () As Long                          'Added to get the port if set by scan
Private Declare Function GetCurrentBaud Lib "Velmex VXM Serial Driver.dll" () As Long                          'Added to get baud if set by scan
Private Declare Function GetScanAbortStatus Lib "Velmex VXM Serial Driver.dll" () As Long                             'Added to get scan abort status
Private Declare Function SetScanAbortStatus Lib "Velmex VXM Serial Driver.dll" (AbortState As Long) As Long                            'Added to set scan abort status

           
'Get Set Motors
Private Declare Function GetMotor Lib "Velmex VXM Serial Driver.dll" (ByVal MotorNumber As Long) As Long
Private Declare Function SetMotor Lib "Velmex VXM Serial Driver.dll" (ByVal MotorNumber As Long, ByVal MotorSetting As Long) As Long
        
'Get Set Limits
Private Declare Function GetLimit Lib "Velmex VXM Serial Driver.dll" (ByVal LimitNumber As Long) As Long
Private Declare Function SetLimit Lib "Velmex VXM Serial Driver.dll" (ByVal LimitNumber As Long, ByVal LimitSetting As Long) As Long
           
'Get Set Program Info
Private Declare Function GetCurrentProgramMemory Lib "Velmex VXM Serial Driver.dll" () As String
Private Declare Function GetCurrentProgramNumber Lib "Velmex VXM Serial Driver.dll" () As String
Private Declare Function SetCurrentProgramNumber Lib "Velmex VXM Serial Driver.dll" (ByVal ProgramNumber As Long) As Long
Private Declare Function GetCurrentProgramListing Lib "Velmex VXM Serial Driver.dll" (ByVal ProgramNumber As Long) As String
   
           
'*** API Functions that are MANDATORY if the driver is not in one of the following 6 directories
'*** 1. The directory from which the application loaded.
'*** 2. The current directory. (If code is compiled into exe, otherwise may fail if in development IDE)
'*** 3. Windows 95: The Windows system directory. Use the GetSystemDirectory function to get the path of this directory.
'*** Windows NT: The 32-bit Windows system directory. Use the GetSystemDirectory function to get the path of this directory. The name of this directory is SYSTEM32.
'*** 4. Windows NT: The 16-bit Windows system directory. There is no Win32 function that obtains the path of this directory, but it is searched. The name of this directory is SYSTEM.
'*** 5. The Windows directory. Use the GetWindowsDirectory function to get the path of this directory.
'*** 6. The directories that are listed in the PATH environment variable.
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public hLib As Long

Public Updating As Boolean
Public CurrentStatus As String
           
Public Event PortChanged(NewPort As String, NewBaud As String)
Public Event PortOpenOrClosed(CurrentStatus As String)
Public Event VxmChanged(CurrentStatus As String)

Public VxmExist As Boolean
Public PrevStatus As String
'Public AbleToJog As Boolean
Public Jogging As Boolean

Public Function LoadDriver(DriverPath As String) As Long        'First we tell windows where the driver resides
Select Case hLib                            'Determine if the driver is already loaded
    Case 0                                  'If driver is not loaded
        hLib = LoadLibrary(DriverPath)      'Load the driver
    Case Else                               'Else
        hLib = FreeLibrary(hLib)            'Unload the driver
        hLib = LoadLibrary(DriverPath)      'Reload the driver
        EscapeDriverFunctionFalse           'enable driver functions
End Select
LoadDriver = hLib                           'Return the handle to the driver to the calling function
End Function

Public Function UnLoadDriver() As Long      'When done, we need to release the driver and resources
Select Case hLib
    Case 0
    Case Else
        Do
            DoEvents
            EscapeDriverFunctionTrue
        Loop Until AreDriverFunctionsEnabled = False
End Select
Do
    DoEvents
    hLib = FreeLibrary(hLib)                    'Release the driver
Loop Until hLib = 0
UnLoadDriver = hLib                         'Relay the release to the calling function
End Function

Public Sub SetCallbackTempBuffer(hwnd As Long)
    SetTempBufferCallback (hwnd)
End Sub

Public Sub SetCallbackBuffer(hwnd As Long)
    SetBufferCallback (hwnd)
End Sub

Public Sub SetCallbackTerminal(hwnd As Long)
    SetTerminalCallback (hwnd)
End Sub

Public Sub SetCallbackReport(hwnd As Long)
    SetReportCallback (hwnd)
End Sub

Public Function DebugWindowShow() As Long       'Show Debug Window
    DebugWindowShow = ShowForm
End Function

Public Function DebugWindowHide() As Long       'Hide Debug Window
    DebugWindowHide = HideForm
End Function

Public Function DebugWindowMove(x As Long, y As Long) As Long 'Move the Dialog Position
    DebugWindowMove = MoveForm(x, y)
End Function

Public Function GetWindowHandle() As Long
GetWindowHandle = WindowHandle
End Function

Public Function IsDebugWindowOpen() As Boolean     'Determine if debug window is open so crash doesnt occur
    Select Case IsFormOpen
        Case 0
            IsDebugWindowOpen = False
        Case 1
            IsDebugWindowOpen = True
    End Select
End Function

Public Function PortOpen(ByVal ComPortNumber As Long, ByVal ComPortBaudRate As Long) As Long    'Configure and open serial port
    PortOpen = OpenPort(ByVal ComPortNumber, ByVal ComPortBaudRate)
    RaiseEvent PortChanged(Trim(Str(ComPortNumber)), Trim(Str(ComPortBaudRate)))
    Call IsSerialPortOpen
End Function

Public Function IsSerialPortOpen() As Boolean
    Dim SerialPortStatus As Long
    SerialPortStatus = IsPortOpen
    Select Case SerialPortStatus
        Case 0
            RaiseEvent PortOpenOrClosed("Closed")
            IsSerialPortOpen = False
        Case 1
            RaiseEvent PortOpenOrClosed("Open")
            IsSerialPortOpen = True
    End Select
    Call VerifyStatus
End Function

Public Function PortClose() As Long
    PortClose = ClosePort
    Call IsSerialPortOpen
End Function

Public Function SendCommandsToPort(ByVal CommandOut As String) As Long 'Send Command to device via Cptr or actual string
    SendCommandsToPort = SendToPort(ByVal CommandOut)
End Function

Public Function ReadReplyFromPort() As String
    ReadReplyFromPort = ReadFromPort
End Function

Public Function ReadReplyAndClearPort() As String
    ReadReplyAndClearPort = ReadAndThenClearFromPort
End Function

Public Function CountNumberCharsAtPort() As Long
    CountNumberCharsAtPort = CountCharsAtPort
End Function

Public Function SearchForCharsAtPort(ByVal CharsToFind As String) As Boolean
    Select Case SearchForChars(ByVal CharsToFind)
        Case 0
            SearchForCharsAtPort = False
        Case 1
            SearchForCharsAtPort = True
    End Select
End Function

Public Function TerminalClean() As Long
    TerminalClean = CleanTerminal
End Function

Public Function TerminalClear() As Long     'Clear the driver terminal
    TerminalClear = ClearTerminal
End Function

Public Function TerminalGet() As String     'Get copy of driver terminal
    TerminalGet = GetTerminal
End Function

Public Function ClearPortChars() As Long
    ClearPortChars = ClearPort
End Function

Public Function RemoveCharsFromPort(ByVal StringToRemove As String) As Long                        'Remove chars from buffer
    RemoveCharsFromPort = RemoveFromPort(ByVal StringToRemove)
End Function

'Verify Control Status Functions
Public Function VerifyStatus() As String
'    Possible Responses:
'        "ONLINEREADY"                'if online and ready to communicate
'        "OFFLINEREADY"               'if offline, but ready to communicate
'        "ONLINEBUSY"                 'if online, but a program is running
'        "OFFLINEBUSY"                'if offline, and a program is running
'        "JOGGING"                    'if offline, but jog button(s) are running
'
'        "ERRORSTOPBUTTON"            'if stop button pushed
'        "ERRORBUSS"                  'if bussing error
'        "ERRORMEMORYFULL"            'if memory is overfilled
'        "ERRORNESTEDLOOP"            'if nested number of loops error
'        "ERRORJUMPANDRETURN"         'if a jump to program and return error
'        "ERRORCONTINUOUSINDEX"       'if a continuous index error
'        "ERRORFLASHROM"              'if a flashrom error
'        "ERROREEPROM"                'if an eeprom error
'        "ERRORINVALIDMOTORNUMBER"    'if an invalid motor
'        "ERRORBUFFEROVERFLOW"        'if a buffer overflow error
'
'        "ERRORCOMMUNICATIONS"        'if some communication error occurred or cannot communicate"
    Me.Updating = True
    CurrentStatus = VerifyControlStatus
    VerifyStatus = CurrentStatus
    RaiseEvent VxmChanged(CurrentStatus)
    Me.Updating = False
End Function

Public Function VerifyState(Optional ByVal StateBuffer As String) As String
    Select Case StateBuffer
        Case ""
            VerifyState = StateCheck("")
        Case Else
            VerifyState = StateCheck(StateBuffer)
    End Select
End Function


'Functions for escaping functions locked into getting reply from VXM
Public Function EscapeDriverFunctionTrue() As Long
    EscapeDriverFunctionTrue = FunctionEscapeTrue
End Function

Public Function EscapeDriverFunctionFalse() As Long
    EscapeDriverFunctionFalse = FunctionEscapeFalse
End Function

Public Function AreDriverFunctionsEnabled() As Boolean
    Select Case AreAllFunctionsEnabled
        Case 0
            AreDriverFunctionsEnabled = False
        Case 1
            AreDriverFunctionsEnabled = True
    End Select
End Function
'Control Online, Offline, and Kill Program functions
Public Function BringOnline() As Long
    Me.SendCommandsToPort "Q"       'Added to eliminate ability to have echo on from outside COSMOS
    BringOnline = Online
    Pause.TimeDelay 0.1
    Call VerifyStatus
End Function

Public Function BringOffline() As Long
    BringOffline = Offline
    Pause.TimeDelay 0.1
    Call VerifyStatus
End Function

Public Function KillProgram() As Long
    KillProgram = KillVxmProgram
    Pause.TimeDelay 0.1
    Call VerifyStatus
End Function

Public Function StopProgram() As Long
    StopProgram = StopVxmProgram
End Function

Public Function GetCurrentMotorPosition(ByVal MotorNumber As Long) As String
    GetCurrentMotorPosition = GetMotorPosition(ByVal MotorNumber)
End Function

'Wait for a char
Public Function WaitForCharacter(ByVal CharToWaitFor As String, Optional ByVal TimeOutTime As Long) As Long
    Select Case TimeOutTime
        Case 0
            WaitForCharacter = WaitForChar(ByVal CharToWaitFor)
        Case Else
            WaitForCharacter = WaitForChar(ByVal CharToWaitFor, ByVal TimeOutTime)
    End Select
    Pause.TimeDelay 0.1
    Call VerifyStatus
End Function

Public Function RunVxmProgram() As Long
    RunVxmProgram = RunProgram
    Call VerifyStatus
End Function

Public Function RunVxmProgramAndWaitForFinish(Optional ByVal TimeOutTime As Long) As Long
    Select Case TimeOutTime
        Case 0
            RunVxmProgramAndWaitForFinish = RunProgramAndWaitForFinish
        Case Else
            RunVxmProgramAndWaitForFinish = RunProgramAndWaitForFinish(ByVal TimeOutTime)
    End Select
    Pause.TimeDelay 0.1
    Call VerifyStatus
End Function

Public Function GetProgramMemory() As String
    GetProgramMemory = GetCurrentProgramMemory
End Function

Public Function GetProgramNumber() As String
    GetProgramNumber = GetCurrentProgramNumber
End Function

Public Function SetProgramNumber(ByVal ProgramNumber As Long) As Long
    SetProgramNumber = SetCurrentProgramNumber(ByVal ProgramNumber)
End Function

Public Function GetProgramListing(ByVal ProgramNumber As Long) As String
    GetProgramListing = GetCurrentProgramListing(ByVal ProgramNumber)
End Function


Public Function SetMotorSetting(ByVal MotorNumber As Long, ByVal MotorSetting As Long)
    SetMotorSetting = SetMotor(ByVal MotorNumber, ByVal MotorSetting)
End Function

Public Function GetMotorSetting(ByVal MotorNumber As Long) As Long
    GetMotorSetting = GetMotor(ByVal MotorNumber)
End Function

Public Function SetLimitSetting(ByVal LimitNumber As Long, ByVal LimitSetting As Long)
    SetLimitSetting = SetLimit(ByVal LimitNumber, ByVal LimitSetting)
End Function

Public Function GetLimitSetting(ByVal LimitNumber As Long) As Long
    GetLimitSetting = GetLimit(ByVal LimitNumber)
End Function

'Detect VXM
Public Function DetectVxm(MaxPortsToScan As Long, Optional hTxtCallback As Long) As Boolean                          'Added due to VerifyControlStatus delayed scan by 1 sec per port setting
    DetectVxm = CBool(DetectControl(MaxPortsToScan, hTxtCallback))
End Function

Public Function GetPort() As Long                             'Added to get the port if set by scan
    GetPort = GetCurrentPort
End Function

Public Function GetBaud() As Long                             'Added to get baud if set by scan
    GetBaud = GetCurrentBaud
End Function

Public Function GetAbortStatus() As Long                                'Added to get scan abort status
    GetAbortStatus = GetScanAbortStatus
End Function

Public Function SetAbortStatus(AbortState As Long) As Long                               'Added to set scan abort status
    SetScanAbortStatus AbortState
End Function

